routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect('/home');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::get('/play', 'PlayController@index')->name('play');
Route::get('/join', 'JoinController@index')->name('join');
Route::get('/privacy', 'GdprController@index')->name('privacy');
Route::get('/search', 'SearchController@index')->name('search.index');

Route::resource('albums', 'AlbumController');
Route::resource('artists', 'ArtistController');
Route::resource('songs', 'SongController');
Route::get('/{type}/{id}/playlist', 'PlaylistController@addToPlaylist')->name('playlist.addToPlaylist');
Route::put('/{type}/{id}/playlist', 'PlaylistController@addToPlaylist')->name('playlist.addToPlaylist');

Route::post('/songs/{id}/queue', 'SongController@enqueue')->name('songs.enqueue');
Route::delete('/songs/{id}/queue', 'SongController@dequeue')->name('songs.dequeue');
Route::delete('/queue', 'SongController@emptySession')->name('songs.flush');

Route::resource('playlists', 'PlaylistController');


Route::resource('profile', 'ProfileController', [
    'only' => ['edit', 'update', 'destroy'],
    'parameters' => ['profile' => 'user']
]);
Route::put('/profile/{id}/theme', 'ProfileController@updateTheme')->name('profile.updateTheme');

/**
 * Redirection
 */
Route::any('{query}', function () {
    return redirect('/home');
})->where('query', '.*');

app/Song.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Song extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'stored_path', 'title', 'bpm', 'json_waveform', 'json_level', 'visibility', 'user_id', 'artist_id', 'album_id'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
    ];

    public function user()
    {
        return $this->belongsTo('App\User');
    }

    public function playlists()
    {
        return $this->belongsToMany('App\Playlist');
    }

    public function album()
    {
        return $this->belongsTo('App\Album');
    }

    public function artist()
    {
        return $this->belongsTo('App\Artist');
    }
}

app/Http/Controllers/SongController.php
<?php

namespace App\Http\Controllers;

use App\Album;
use App\Artist;
use App\Repositories\AlbumRepository;
use App\Repositories\ArtistRepository;
use App\Repositories\SongRepository;
use App\Song;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Auth;
use Illuminate\Validation\Rule;

class SongController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @param SongRepository $songRepository
     * @param Request $request
     * @return Response
     */
    public function index(SongRepository $songRepository, Request $request)
    {
        $q = null;
        $pagination = $request->has('pagination') ? $request->get('pagination') : 5;

        if ($request->has('q')) {
            $validatedData = $request->validate([
                'q' => 'required|string'
            ]);

            $q = $validatedData['q'];
        }

        if (Auth::check()) {
            $songs = isset($q) ? $songRepository->searchPrivateSong($q, Auth::user()->id, $pagination) : $songRepository->getWithUser(Auth::user()->id, $pagination);
            $public_songs = isset($q) ? $songRepository->searchPublicSong($q, $pagination) : $songRepository->getPublic($pagination);
            return view('songs.listing_songs', compact('songs', 'public_songs', 'pagination'));
        } else {
            $public_songs = isset($q) ? $songRepository->searchPublicSong($q, $pagination) : $songRepository->getPublic($pagination);
            return view('songs.listing_songs', compact('public_songs', 'pagination'));
        }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Response
     */
    public function create()
    {
        return view('songs.add_song');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param Request $request
     * @param SongRepository $songRepository
     * @param AlbumRepository $albumRepository
     * @param ArtistRepository $artistRepository
     * @return Response
     */
    public function store(Request $request, SongRepository $songRepository, AlbumRepository $albumRepository, ArtistRepository $artistRepository)
    {
        $validatedData = $request->validate([
            'bpm' => 'required|integer',
            'artist' => 'nullable|string',
            'album' => 'nullable|string',
            'title' => 'required|string',
            'song' => 'required|file|mimetypes:audio/mpeg,audio/x-wav,application/octet-stream|max:15000',
            'visibility' => ['required', 'string', Rule::in(['public', 'private'])]
        ]);

        if (Auth::user()->type_user != 'admin' && $validatedData['visibility'] === 'public') {
            return redirect()->back()->withErrors(['Only admins can upload public songs']);
        }

        if (isset($validatedData['artist'])) {
            $artist = Artist::where('name', $validatedData['artist'])->first();
            if (isset($artist)) {
                $validatedData['artist_id'] = $artist->id;
            } else {
                $artist = $artistRepository->store(['name' => $validatedData['artist']]);
                $validatedData['artist_id'] = $artist->id;
            }
        }

        if (isset($validatedData['album'])) {
            $album = Album::where('name', $validatedData['album'])->first();
            if (isset($album)) {
                $validatedData['album_id'] = $album->id;
            } else {
                $album = $albumRepository->store(['name' => $validatedData['album']]);
                $validatedData['album_id'] = $album->id;
            }
            if (isset($validatedData['artist_id']) && $album->artist_id === null) {
                $album->artist_id = $validatedData['artist_id'];
                $album->save();
            }
        }

        $uniqueid = uniqid();
        $extension = $request->file('song')->getClientOriginalExtension();
        $name = $uniqueid . '.' . $extension;
        $path = $request->file('song')->storeAs('songs', $name);
        $storedPath = 'storage/' . $path;
        shell_exec('/usr/local/bin/audiowaveform -i ' . $storedPath . ' -o ' . $storedPath . '.dat --pixels-per-second 20 --bits 8');
        shell_exec('/usr/local/bin/audiowaveform -i ' . $storedPath . '.dat -o ' . $storedPath . '.json');
        shell_exec('python scale-json.py ' . $storedPath . '.json ' . $storedPath . '_level_.json');
        $json_waveform = file_get_contents($storedPath . '.json');
        $json_level = file_get_contents($storedPath . '_level_.json');
        exec('rm ' . $storedPath . '.dat ' . $storedPath . '.json ' . $storedPath . '_level_.json');
        $validatedData['stored_path'] = $storedPath;
        $validatedData['json_waveform'] = $json_waveform;
        $validatedData['json_level'] = $json_level;
        $validatedData['user_id'] = Auth::user()->id;
        unset($validatedData['album']);
        unset($validatedData['artist']);

        $songRepository->store($validatedData);
        return redirect()->back()->with('message', 'Song uploaded');
    }

    public function enqueue($id, Request $request)
    {
        $song = Song::findOrFail($id);
        $uniqueid = uniqid();
        $song['uniqueid'] = $uniqueid;
        $request->session()->put('songs.song_' . $uniqueid, $song);
        return response()->json($song);
    }

    public function dequeue($uniqueid)
    {
        foreach (session()->get('songs') as $song) {
            if ($song->uniqueid == $uniqueid) {
                session()->forget('songs.song_' . $uniqueid);
            }
        }
    }

    public function emptySession()
    {
        session()->forget('songs');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param $id
     * @return void
     * @throws Exception
     */
    public function destroy($id)
    {
        /** @var $song Song */
        $song = Song::findOrFail($id);
        unlink($song->stored_path);
        $song->delete();
        return response()->json(['type' => 'success', 'message' => 'Song deleted']);
    }
}

resources/views/songs/add_song.blade.php
@extends('partials.iframe-tab')
@section('tab')
<div class="row justify-content-center">
    <div class="col-md-8 col-lg-4 mt-3">

        @if(session()->has('message'))
        <div class="alert alert-success alert-dismissable">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
            {{ session()->get('message') }}
        </div>
        @endif
        @if($errors->any())
        <div class="alert alert-danger alert-dismissable">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
            {{ $errors->first() }}
        </div>
        @endif
        <div class="card t50 rounded">
            <div class="card-header d-flex">
                <div class="media-body">
                    <a href="{{route('songs.index')}}" class="btn"><i>@svg('solid/angle-left', 'icon-white')</i></a>
                </div>
                <h2 class="text-white align-self-center m-0">{{ __('Upload a song') }}</h2>
                <div class="media-body"></div>
            </div>

            <div class="card-body">
                <form method="POST" id="addSong" action="{{ route('songs.store') }}" enctype="multipart/form-data">
                    @csrf

                    <div class="input-group">
                        <div class="custom-file">
                            <input type="file" class="custom-file-input" id="inputGroupFile01" name="song"
                                onchange='readFile(event)'>
                            <label class="custom-file-label" for="inputGroupFile01">{{__('Choose file')}}</label>

                            @error('song')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                            @enderror
                        </div>
                    </div>
                    <small class="form-text text-muted mb-3">{{__('MP3 or Wav files, not more than 15mb. ')}}</small>

                    @admin
                    <label>{{ __('Visibility') }}</label>
                    <div class="d-block">
                        <div class="custom-control custom-radio custom-control-inline">
                            <input type="radio" id="public" name="visibility" class="custom-control-input"
                                value="public" checked>
                            <label class="custom-control-label" for="public">{{__('Public')}}</label>
                        </div>
                        <div class="custom-control custom-radio custom-control-inline">
                            <input type="radio" id="private" name="visibility" class="custom-control-input"
                                value="private">
                            <label class="custom-control-label" for="private">{{__('Private')}}</label>
                        </div>
                    </div>
                    @else
                    <input type="hidden" value="private" name="visibility">
                    @endadmin

                    <hr>

                    <div class="mt-4 mb-3 title-group">
                        <h4 class="d-inline">{{ __('Edit Metadatas') }}</h4>
                    </div>

                    <input type="hidden" value="0" name="bpm" id="songBpm">

                    <div class="form-group">
                        <label for="album">{{ __('Album') }}</label>
                        <input id="album" type="text" class="form-control @error('album') is-invalid @enderror"
                            name="album" value="{{ old('album') }}" autocomplete="album">
                        @error('album')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                        @enderror
                    </div>

                    <div class="form-group">
                        <label for="artist">{{ __('Artist') }}</label>
                        <input id="artist" type="text" class="form-control @error('artist') is-invalid @enderror"
                            name="artist" value="{{ old('artist') }}" autocomplete="artist">

                        @error('artist')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                        @enderror
                    </div>

                    <div class="form-group">
                        <label for="title">{{ __('Title') }}</label>
                        <input id="title" type="text" class="form-control @error('title') is-invalid @enderror"
                            name="title" value="{{ old('title') }}" autocomplete="title">

                        @error('title')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                        @enderror
                    </div>

                    <div class="form-group">
                        <button class="btn btn-impulsy btn-block" type="submit" id="submitForm">
                            <span id="spin1" class="d-none spinner-border spinner-border-sm" role="status"
                                aria-hidden="true"></span>
                            <span id="spin2" class="d-none">Loading...</span>
                            <span id="spin_upload">{{ __('Upload') }}</span>
                        </button>
                    </div>

                </form>
            </div>
        </div>
    </div>
</div>
@endsection
@section('scripts')
@include('partials.script-bpm')
@endsection

resources/views/songs/listing_songs.blade.php
@extends('partials.iframe-tab')
@section('tab')
    <div class="row justify-content-center">
        <div class="col-md-12 mt-2">
            @if(session()->has('message'))
                <div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    {{ session()->get('message') }}
                </div>
            @endif
            @if($errors->any())
                <div class="alert alert-danger alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    {{ $errors->first() }}
                </div>
            @endif
            <div class="title-group">
                <h2 class="d-inline text-pink">{{ __('Titles') }}</h2>
            </div>
            @auth
                <a href="{{route('songs.create')}}" class="btn btn-impulsy btn-block mt-3 create">{{ __('Add') }}</a>
            @endauth
            @auth
                <ul class="mt-3">
                    @foreach($songs as $song)
                        <li class="bg-transparent">
                            <a class="cursor-pointer"
                               onclick="play({{ json_encode(route('songs.enqueue', $song->id)) }})">
                                <span class="h4">{{ $song->title }}</span>
                            </a>
                            <span class="float-right">
                                <div class="dropdown d-inline">
                                    <a id="addDropdown" href="#" role="button"
                                       data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        <i class="mr-3">@svg('solid/plus', 'icon-sm icon-white')</i>
                                    </a>

                                    <div class="dropdown-menu dropdown-menu-right" aria-labelledby="addDropdown">
                                        <a class="dropdown-item" href="#"
                                           onclick="enqueue({{ json_encode(route('songs.enqueue', $song->id)) }})">
                                            {{ __('Add to queue') }}
                                        </a>

                                        @auth
                                            <a class="dropdown-item" href="#modalForm" data-toggle="modal"
                                               data-href="{{route('playlist.addToPlaylist', ['type' => 'song', $song->id])}}">
                                                {{ __('Add to playlist') }}
                                            </a>
                                        @endauth
                                    </div>
                                </div>
                                <a class="delete" href="{{ route('songs.destroy', $song->id) }}">
                                    <i>@svg('solid/times', 'icon-sm icon-white')</i>
                                </a>
                            </span>
                        </li>
                    @endforeach
                </ul>
                <div
                    class="mt-2">{{ $songs->appends(array_except(Request()->query(), 'private_pagination'))->links() }}</div>
            @endauth
            <ul class="mt-3">
                @foreach($public_songs as $song)
                    <li class="bg-transparent">
                        <a class="cursor-pointer"
                           onclick="play({{ json_encode(route('songs.enqueue', $song->id)) }})">
                            <span class="h4">{{ $song->title }}</span>
                        </a>
                        <span class="float-right">
                            <div class="dropdown d-inline">
                                    <a id="addDropdown" href="#" role="button"
                                       data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        <i class="mr-3">@svg('solid/plus', 'icon-sm icon-white')</i>
                                    </a>

                                    <div class="dropdown-menu dropdown-menu-right" aria-labelledby="addDropdown">
                                        <a class="dropdown-item" href="#"
                                           onclick="enqueue({{ json_encode(route('songs.enqueue', $song->id)) }})">
                                            {{ __('Add to queue') }}
                                        </a>

                                        @auth
                                            <a class="dropdown-item" href="#modalForm"
                                               data-href="{{route('playlist.addToPlaylist', ['type' => 'song', $song->id])}}"
                                               data-toggle="modal">
                                            {{ __('Add to playlist') }}
                                            </a>
                                        @endauth
                                    </div>
                                </div>
                            @admin
                                <a class="delete" href="{{ route('songs.destroy', $song->id) }}">
                                    <i>@svg('solid/times', 'icon-sm icon-white')</i>
                                </a>
                            @endadmin
                        </span>
                    </li>
                @endforeach
            </ul>
            <div class="mt-2">{{ $public_songs->appends(array_except(Request()->query(), 'page'))->links() }}</div>
            <form class="float-right">
                <select name="pagination" id="numberItems">
                    <option value="5" @if($pagination == 5) selected @endif >{{__('5')}}</option>
                    <option value="10" @if($pagination == 10) selected @endif >{{__('10')}}</option>
                    <option value="25" @if($pagination == 25) selected @endif >{{__('25')}}</option>
                </select>
            </form>
        </div>
    </div>
@endsection
@section('scripts')
    <script>
        document.getElementById('numberItems').onchange = function () {
            window.location = "{{route('songs.index')}}?pagination=" + this.value;
        };
    </script>
@endsection